//
//	PI
//

#ifndef		_PI_INC_
#define		_PI_INC_

#include <stdlib.h>
#include <memory.h>

class Pi
{
private:
	enum { OVER_PREC = 5 };
	char * p;
	char * t;
	int    q;
	int    a;
	int    n;
private:
	void add()
	{
		for (int i = q; i >= 0; i--) {
			p[i] += t[i];
			if (p[i] >= 10) {
				p[i] -= 10;
				p[i - 1]++;
			}
		}
	}
	void sub()
	{
		for (int i = q; i >= 0; i--) {
			if (p[i] < t[i]) {
				p[i] += 10;
				p[i - 1]--;
			}
			p[i] -= t[i];
		}
	}
	void mul(int m)
	{
		int c = 0;
		for (int i = q; i >= 0; i--) {
			int b = t[i] * m + c;
			int d = b % 10;
			    c = b / 10;
			t[i]  = d;
		}
	}
	void div(int d)
	{
		int r = 0;
		for (int i = 0; i <= q; i++) {
			int b = 10 * r + t[i];
			int u = b / d;
			    r = b % d;
			t[i]  = u;
		}
	}
	void mul4()
	{
		int c = 0;
		for (int i = q; i >= 0; i--) {
			int d = (p[i] * 4 + c) % 10;
			    c = (p[i] * 4 + c) / 10;
			p[i]  = d;
		}
	}
	int diff()
	{
		int i;
		for (i = 0; i <= q; i++) {
			if (t[i] != 0)
				return i;
		}
		return -1;
	}
	void arctan_init(int s)
	{
		t[0] = 1;
		div(s);
		add();
		n = 1;
	}
	int arctan_do(int s)
	{
		mul(n);
		div(s * s);
		div(n += 2);
		if ((n & 2) == 0)
			add();
		else
			sub();
		return diff();
	}
public:
	void destroy()
	{
		free(p);
		free(t);
		p = NULL;
		t = NULL;
		q = -1;
		a = -1;
	}
	bool create(int prec)
	{
		if (prec < 0)
			return false;
		destroy();
		prec += OVER_PREC;
		p = (char *)malloc(prec + 1);
		t = (char *)malloc(prec + 1);
		if (!p || !t)
			return false;
		q = prec;
		return true;
	}
	bool reset()
	{
		if (q < 0)
			return false;
		memset(p, 0, q + 1);
		memset(t, 0, q + 1);
		a = -1;
		return true;
	}
	int start()
	{
		if (!reset())
			return 0;
		arctan_init(a = 2);
		return q * 2 + 1;
	}
	int calc()
	{
		if (a < 2)
			return 0;
		int r = arctan_do(a);
		if (r < 0) {
			if (a == 2) {
				arctan_init(a = 3);
				return q;
			}
			mul4();
			a = -1;
			return -1;
		}
		return q * (a - 2) + r;
	}
	int tostr(char *buf, bool separate = true)
	{
		if (q < 0)
			return 0;
		int digit = q - OVER_PREC;
		if (!buf) {
			return separate
				? 4 + digit + digit / 10 + digit / 100 + 1
				: 2 + digit + 1;
		}
		*buf++ = '0' + p[0];
		*buf++ = '.';
		if (separate) {
			*buf++ = '\r';
			*buf++ = '\n';
		}
		for (int i = 1; i <= digit; i++) {
			*buf++ = '0' + p[i];
			if (separate) {
				if (i % 10 == 0) {
					if (i % 100 == 0) {
						*buf++ = '\r';
						*buf++ = '\n';
					} else {
						*buf++ = ' ';
					}
				}
			}
		}
		*buf = '\0';
		return separate
			? 4 + digit + digit / 10 + digit / 100 + 1
			: 2 + digit + 1;
	}
public:
	Pi()
	{
		p = NULL;
		t = NULL;
		q = -1;
		a = -1;
	}
	~Pi()
	{
		destroy();
	}
};

#endif	//	_PI_INC_
